 
load sonar.mat
[ns nf] = size(Data);
%  
%  ms = mean(Data); 
%  sgs = std(Data); 
%  Data = (Data - repmat(ms,ns,1))./repmat(sgs,ns,1);
 
% %  
%-------------------------------------
C = 10.^[0];
rho = 10.^[-1];
maxiters = 5000;
tol = 1e-6;
 
 
nos = length(Label);
nte = floor(nos*0.2);
ntr = nos-nte;
 
 
 
     ind = randperm(nos);
   
    %chooose optimal gaussian parameter
    Y = Label(ind);
    Ytr = Y(1:ntr);
    Yte = Y(ntr+1:end);
    xtr = Data(ind(1:ntr), :);
    [optgs, optC, cvaccu] = libsvm_cv(xtr, Ytr, C, 3.^[-4:4], 5); 
     
    %creating kernel matrix
    k_type = 'gauss'; 
    psdK = create_kernel(Data(ind,:), Data(ind,:), k_type, optgs); 
    %adding noise information
    E = mvnrnd(zeros(nos,1),eye(nos),nos);
    E =  (E+E')./2;
    K = psdK - 0.1*E;
 
    tempK = K;
    [VV,TD]= eig(tempK(1:ntr,1:ntr));
    glmax = max(diag(real(TD)));
    glmin = min(diag(real(TD)));
    
     

    %%%running smoothing optimization method
    [U, DD] = svd(tempK(1:ntr,1:ntr)); DD = diag(real(DD));
    L = sqrt(max(DD)) + ntr*optC^2/rho;
   [alpha,history]= IndefiniteSVM_nes(tempK(1:ntr,1:ntr), Ytr, C, rho, L, tol, maxiters,1); 
   [pred,accu,recall,precision]=IndSVMerror(alpha, Ytr, Yte, tempK,C,rho); % get the error
   

